using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace Graphique
{
 public partial class Form1 : Form
 {
  struct VALEUR
  {
   public int Val;
   public Color Coul;
  };
  VALEUR[] tabVal = new VALEUR[4];
  public Form1()
  {
   InitializeComponent();
  }

  private void Form1_Load(object sender, EventArgs e)
  {
   tabVal[0].Val = 6; tabVal[0].Coul = Color.Red;
   tabVal[1].Val = 4; tabVal[1].Coul = Color.Lime;
   tabVal[2].Val = 8; tabVal[2].Coul = Color.Blue;
   tabVal[3].Val = 12; tabVal[3].Coul = Color.Olive;

   // Pour barres de dfilement
   this.AutoScrollMinSize = this.ClientSize;
  }

  private void udVal_ValueChanged(object sender, System.EventArgs e)
  {
   tabVal[0].Val = (int)udVal1.Value;
   tabVal[1].Val = (int)udVal2.Value;
   tabVal[2].Val = (int)udVal3.Value;

   int n = 30 - (tabVal[0].Val + tabVal[1].Val + tabVal[2].Val);
   zaVal4.Text = n.ToString();
   tabVal[3].Val = n;
  }
  int GraphiqueADessiner; // 0 : aucun, 1 : barres, 2 : pie
  private void bBarres_Click(object sender, System.EventArgs e)
  {
   GraphiqueADessiner = 1;
   Invalidate();
  }

  private void bPie_Click(object sender, System.EventArgs e)
  {
   GraphiqueADessiner = 2;
   Invalidate();
  }

  private void Form1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
  {
   Rectangle rc;
   Point pStart = this.AutoScrollPosition;
   e.Graphics.SmoothingMode = SmoothingMode.HighQuality;
   switch (GraphiqueADessiner)
   {
    case 1:                   // graphique  barres
     int X = pStart.X + 350, Y = pStart.Y + 15;
     foreach (VALEUR v in tabVal)
     {
      int H = v.Val * 15;       // 15 pixels par unit
      rc = new Rectangle(X, Y + 300 - H, 75, H);
      e.Graphics.FillRectangle(new SolidBrush(v.Coul), rc);
      string s = String.Format("{0:0.0%}", v.Val / 30.0);
      e.Graphics.DrawString(s, new Font("Arial", 12, FontStyle.Bold),
                            new SolidBrush(v.Coul), X + 15, Y + 315);
      X += 75;
     }
     break;
    case 2:                  // camembert
     int AngleStart = 0, Angle;
     rc = new Rectangle(pStart.X + 350, pStart.Y + 50, 300, 300);
     foreach (VALEUR v in tabVal)
     {
      Angle = 360 * v.Val / 30;
      e.Graphics.FillPie(new SolidBrush(v.Coul), rc, AngleStart, Angle);
      int xStr = pStart.X + 350 + 300 / 2 + (int)(180 * Math.Cos(2 * 3.14 * (AngleStart + Angle / 2) / 360));
      int yStr = pStart.Y + 50 + 300 / 2 + (int)(180 * Math.Sin(2 * 3.14 * (AngleStart + Angle / 2) / 360));
      string s = String.Format("{0:0.0%}", v.Val / 30.0);
      e.Graphics.DrawString(s, new Font("Arial", 10, FontStyle.Bold),
                            new SolidBrush(v.Coul), xStr, yStr);
      AngleStart += Angle;
     }
     break;
   }
  }
 }
}